.DATA

com_subkey1	db "SOFTWARE\Classes\CLSID\{ca370042-e737-11d9-8cd6-0800200c9a66}",0
com_subkey2	db "SOFTWARE\Classes\CLSID\{ca370042-e737-11d9-8cd6-0800200c9a66}\InprocServer32",0
com_subkey3	db "SOFTWARE\Classes\CLSID\{ca370042-e737-11d9-8cd6-0800200c9a66}\ProgID",0
com_subkey4	db "SOFTWARE\Classes\CLSID\{ca370042-e737-11d9-8cd6-0800200c9a66}\TypeLib",0
com_subkey5	db "SOFTWARE\Classes\CLSID\{ca370042-e737-11d9-8cd6-0800200c9a66}\VersionIndependentProgID",0
com_subkey6	db "SOFTWARE\Classes\Iecm\CLSID",0
com_subkey8	db "SOFTWARE\Classes\Iecm",0
com_subkey7	db "SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Browser Helper Objects\{ca370042-e737-11d9-8cd6-0800200c9a66}",0

IECM_Class	db "IECM Class",0
ThreadingModel	db "ThreadingModel",0
Apartment	db "Apartment",0
Iecm		db "Iecm",0
iecm_tl_CLSID	db "{ca370040-e737-11d9-8cd6-0800200c9a66}",0

.CODE

load_iecm PROC

	pushad

	invoke	LoadLibrary, S("iecm.dll")
	mov	[hIecm], eax
	test	eax, eax
	je	error

	invoke	GetProcAddress, eax, S("DllRegisterServer")
	test	eax, eax
	je	error

	call	eax

			;[SOFTWARE\Classes\CLSID\{ca370042-e737-11d9-8cd6-0800200c9a66}]
			; @="IECM Class"

			; [SOFTWARE\Classes\CLSID\{ca370042-e737-11d9-8cd6-0800200c9a66}\InprocServer32]
			; @="FULLPATH TO THE DLL"
			; "ThreadingModel"="Apartment"

			; [SOFTWARE\Classes\CLSID\{ca370042-e737-11d9-8cd6-0800200c9a66}\ProgID]
			; @="Iecm"

			; [SOFTWARE\Classes\CLSID\{ca370042-e737-11d9-8cd6-0800200c9a66}\TypeLib]
			; @="{ca370040-e737-11d9-8cd6-0800200c9a66}"

			; [SOFTWARE\Classes\CLSID\{ca370042-e737-11d9-8cd6-0800200c9a66}\VersionIndependentProgID]
			; @="Iecm"

	invoke	RegCreateKeyEx, HKEY_LOCAL_MACHINE, ADDR com_subkey1, 0, 0, 0, KEY_WRITE, 0, ADDR tempread, 0
  	cmp	eax, ERROR_SUCCESS
	jne	error
	invoke	RegSetValueEx, tempread, 0, 0, REG_SZ, ADDR IECM_Class, sizeof IECM_Class
	invoke	RegCloseKey, [tempread]

	invoke	GetModuleFileName, [hIecm], ADDR tmpdata, MAX_PATH
	test	eax, eax
	je	error
	mov	ebx, eax

	invoke	RegCreateKeyEx, HKEY_LOCAL_MACHINE, ADDR com_subkey2, 0, 0, 0, KEY_WRITE, 0, ADDR tempread, 0
  	cmp	eax, ERROR_SUCCESS
	jne	error
	invoke	RegSetValueEx, tempread, 0, 0, REG_SZ, ADDR tmpdata, ebx
	invoke	RegSetValueEx, tempread, ADDR ThreadingModel, 0, REG_SZ, ADDR Apartment, sizeof Apartment
	invoke	RegCloseKey, [tempread]

	invoke	RegCreateKeyEx, HKEY_LOCAL_MACHINE, ADDR com_subkey3, 0, 0, 0, KEY_WRITE, 0, ADDR tempread, 0
  	cmp	eax, ERROR_SUCCESS
	jne	error
	invoke	RegSetValueEx, tempread, 0, 0, REG_SZ, ADDR Iecm, sizeof Iecm
	invoke	RegCloseKey, [tempread]

	invoke	RegCreateKeyEx, HKEY_LOCAL_MACHINE, ADDR com_subkey4, 0, 0, 0, KEY_WRITE, 0, ADDR tempread, 0
  	cmp	eax, ERROR_SUCCESS
	jne	error
	invoke	RegSetValueEx, tempread, 0, 0, REG_SZ, ADDR iecm_tl_CLSID, sizeof iecm_tl_CLSID
	invoke	RegCloseKey, [tempread]

	invoke	RegCreateKeyEx, HKEY_LOCAL_MACHINE, ADDR com_subkey5, 0, 0, 0, KEY_WRITE, 0, ADDR tempread, 0
  	cmp	eax, ERROR_SUCCESS
	jne	error
	invoke	RegSetValueEx, tempread, 0, 0, REG_SZ, ADDR Iecm, sizeof Iecm
	invoke	RegCloseKey, [tempread]

			; [SOFTWARE\Classes\Iecm]
			; @="IECM Class"

			; [SOFTWARE\Classes\Iecm\CLSID]
			; @="{ca370042-e737-11d9-8cd6-0800200c9a66}"

	invoke	RegCreateKeyEx, HKEY_LOCAL_MACHINE, ADDR com_subkey8, 0, 0, 0, KEY_WRITE, 0, ADDR tempread, 0
  	cmp	eax, ERROR_SUCCESS
	jne	error
	invoke	RegSetValueEx, tempread, 0, 0, REG_SZ, ADDR IECM_Class, sizeof IECM_Class
	invoke	RegCloseKey, [tempread]

	invoke	RegCreateKeyEx, HKEY_LOCAL_MACHINE, ADDR com_subkey6, 0, 0, 0, KEY_WRITE, 0, ADDR tempread, 0
  	cmp	eax, ERROR_SUCCESS
	jne	error
	invoke	RegSetValueEx, tempread, 0, 0, REG_SZ, ADDR com_subkey1+23, sizeof IECM_Class
	invoke	RegCloseKey, [tempread]

	; [SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Browser Helper Objects\{ca370042-e737-11d9-8cd6-0800200c9a66}]

	invoke	RegCreateKeyEx, HKEY_LOCAL_MACHINE, ADDR com_subkey7, 0, 0, 0, KEY_WRITE, 0, ADDR tempread, 0
  	cmp	eax, ERROR_SUCCESS
	jne	error
	invoke	RegCloseKey, [tempread]


	popad
	xor	eax, eax
	ret

error:	popad
	mov	eax, 1
	ret

load_iecm ENDP